// 2013/01/06
// program by Okuta
// 漢字パズル　へんとつくり

var gosaX = 80;
var gosaY = 60;

var setFlagU =0;
var setFlagL =0;
var myFlag01 ="";
var myFlag02 ="";
var itiX = 0;
var itiY = 0;

var timeFlag = 0;
var touchNumber = 0;
var touchX = 0;
var touchY = 0;
var myTime = 0;
var nowTime = 0;

var img011 ="image/word011.png";
var img012 ="image/word012.png";
var img013 ="image/word013.png";
var img014 ="image/word014.png";
var img015 ="image/word015.png";

var img021 ="image/word021.png";
var img022 ="image/word022.png";
var img023 ="image/word023.png";
var img024 ="image/word024.png";
var img025 ="image/word025.png";
var img026 ="image/word026.png";

var imgMaru ="image/maru.png";

enchant();

window.onload = function() {
    var game = new Game(900, 600);

    game.preload(img011);
    game.preload(img012);
    game.preload(img013);
    game.preload(img014);
    game.preload(img015);

    game.preload(img021);
    game.preload(img022);
    game.preload(img023);
    game.preload(img024);
    game.preload(img025);
    game.preload(img026);
        
    game.preload(imgMaru);
    
    game.onload = function() {
        //スタート画面表示
        var backEntity = new Entity();
        backEntity.width = 900;
        backEntity.height= 600;
        backEntity.moveTo(0,0);
        backEntity.backgroundColor = "#040";
        game.rootScene.addChild(backEntity);

        var lblTitle = new enchant.Label();
        lblTitle.text = "へんとつくり";
        lblTitle.moveTo(10,1);
        lblTitle.width = 200;
        lblTitle.height = 40;
        lblTitle.font = "32px 'Arial'";
        lblTitle.color = "#fff";
        game.rootScene.addChild(lblTitle);

        var lblTitle2 = new enchant.Label();
        lblTitle2.text = "カードをドラッグしてまん中に<br>入れて漢字をつくりましょう。";
        lblTitle2.moveTo(10,40);
        lblTitle2.width = 300;
        lblTitle2.height = 50;
        lblTitle2.font = "18px 'Arial'";
        lblTitle2.color = "#fff";
        game.rootScene.addChild(lblTitle2);

        var lblText = new enchant.Label();
        lblText.text = "";
        lblText.moveTo(270,3);
        lblText.width = 600;
        lblText.height = 50;
        lblText.font = "36px 'Arial'";
        lblText.color = "#fff";
        game.rootScene.addChild(lblText);

        var lblSetumei = new enchant.Label();
        lblSetumei.text = "";
        lblSetumei.moveTo(500,100);
        lblSetumei.width = 400;
        lblSetumei.height =400;
        lblSetumei.font = "65px 'Arial'";
        lblSetumei.color = "#fff";
        game.rootScene.addChild(lblSetumei);
        
        //ボタン        
        var btnNext = new Button("もういちど<br>チャレンジ","blue");
        btnNext.moveTo(300, 320);
        btnNext.width = 180;
        btnNext.height = 80;
        btnNext.font = "28px 'Arial'";
        btnNext.visible = false;
        game.rootScene.addChild(btnNext);
        
        
        var baseEntity = new Entity();
        baseEntity.width = 200;
        baseEntity.height= 200;
        baseEntity.moveTo(300,80);
        baseEntity.backgroundColor = "#ccc";
        game.rootScene.addChild(baseEntity);

        //操作させないためのカバー
        var coverEntity = new Entity();
        coverEntity.width = 900;
        coverEntity.height= 600;
        coverEntity.moveTo(0,0);
        coverEntity.backgroundColor = "rgba(255,255,255,0.0)";
        
        //へん1
        var z011 = new Sprite(80,200);
        z011.image =game.assets[img011];
        z011.moveTo(20, 120);
        game.rootScene.addChild(z011);
        
        var z012 = new Sprite(80,200);
        z012.image =game.assets[img012];
        z012.moveTo(110, 120);
        game.rootScene.addChild(z012);
        
        var z013 = new Sprite(80,200);
        z013.image =game.assets[img013];
        z013.moveTo(20, 360);
        game.rootScene.addChild(z013);
        
        var z014 = new Sprite(80,200);
        z014.image =game.assets[img014];
        z014.moveTo(110, 360);
        game.rootScene.addChild(z014);
        
        var z015 = new Sprite(80,200);
        z015.image =game.assets[img015];
        z015.moveTo(200, 360);
        game.rootScene.addChild(z015);
        
        //した
        var z021 = new Sprite(120,200);
        z021.image =game.assets[img021];
        z021.moveTo(610, 120);
        game.rootScene.addChild(z021);
        
        var z022 = new Sprite(120,200);
        z022.image =game.assets[img022];
        z022.moveTo(740, 120);
        game.rootScene.addChild(z022);
        
        var z023 = new Sprite(120,200);
        z023.image =game.assets[img023];
        z023.moveTo(350, 360);
        game.rootScene.addChild(z023);
        
        var z024 = new Sprite(120,200);
        z024.image =game.assets[img024];
        z024.moveTo(480, 360);
        game.rootScene.addChild(z024);
        
        var z025 = new Sprite(120,200);
        z025.image =game.assets[img025];
        z025.moveTo(610, 360);
        game.rootScene.addChild(z025);
        
        var z026 = new Sprite(120,200);
        z026.image =game.assets[img026];
        z026.moveTo(740, 360);
        game.rootScene.addChild(z026);
                
        var spMaru = new Sprite(210,210);
        spMaru.image =game.assets[imgMaru];
        spMaru.moveTo(baseEntity.x -5, baseEntity.y - 5);
        //spMaru.visible =false;
        
        //タッチした・・・
        z011.ontouchstart = function(e){
            touchNumber = 11;
            touchX = e.x - this.x ;
            touchY = e.y - this.y;
            this.parentNode.removeChild(this);
            game.rootScene.addChild(z011);
        };
        
        z012.ontouchstart = function(e){
            touchNumber = 12;
            touchX = e.x - this.x ;
            touchY = e.y - this.y;
            this.parentNode.removeChild(this);
            game.rootScene.addChild(z012);
        };
        
        z013.ontouchstart = function(e){
            touchNumber = 13;
            touchX = e.x - this.x ;
            touchY = e.y - this.y;
            this.parentNode.removeChild(this);
            game.rootScene.addChild(z013);
        };
        
        z014.ontouchstart = function(e){
            touchNumber = 14;
            touchX = e.x - this.x ;
            touchY = e.y - this.y;
            this.parentNode.removeChild(this);
            game.rootScene.addChild(z014);
        };
        
        z015.ontouchstart = function(e){
            touchNumber = 15;
            touchX = e.x - this.x ;
            touchY = e.y - this.y;
            this.parentNode.removeChild(this);
            game.rootScene.addChild(z015);
        };
        
        z021.ontouchstart = function(e){
            touchNumber = 21;
            touchX = e.x - this.x ;
            touchY = e.y - this.y;
            this.parentNode.removeChild(this);
            game.rootScene.addChild(z021);
        };
        
        z022.ontouchstart = function(e){
            touchNumber = 22;
            touchX = e.x - this.x ;
            touchY = e.y - this.y;
            this.parentNode.removeChild(this);
            game.rootScene.addChild(z022);
        };
        
        z023.ontouchstart = function(e){
            touchNumber = 23;
            touchX = e.x - this.x ;
            touchY = e.y - this.y;
            this.parentNode.removeChild(this);
            game.rootScene.addChild(z023);
        };
        
        z024.ontouchstart = function(e){
            touchNumber = 24;
            touchX = e.x - this.x ;
            touchY = e.y - this.y;
            this.parentNode.removeChild(this);
            game.rootScene.addChild(z024);
        };
        
        z025.ontouchstart = function(e){
            touchNumber = 25;
            touchX = e.x - this.x ;
            touchY = e.y - this.y;
            this.parentNode.removeChild(this);
            game.rootScene.addChild(z025);
        };
        
        z026.ontouchstart = function(e){
            touchNumber = 26;
            touchX = e.x - this.x ;
            touchY = e.y - this.y;
            this.parentNode.removeChild(this);
            game.rootScene.addChild(z026);
        };
        
        
        //はなした・・・
        game.rootScene.ontouchend = function(e){
            touchNumber = 0;
        };
        
        function funcReMoveU(){
            if(setFlagU !=11){
                z011.moveTo(20, 120);
            };
            if(setFlagU !=12){
                z012.moveTo(110, 120);
            };
            if(setFlagU !=13){
                z013.moveTo(20, 360);
            };
            if(setFlagU !=14){
                z014.moveTo(110, 360);
            };
            if(setFlagU !=15){
                z015.moveTo(200, 360);
            };
        }        
        
        function funcReMoveL(){
            if(setFlagL !=21){
                z021.moveTo(610, 120);
            };
            if(setFlagL !=22){
                z022.moveTo(740, 120);
            };
            if(setFlagL !=23){
                z023.moveTo(350, 360);
            };
            if(setFlagL !=24){
                z024.moveTo(480, 360);
            };
            if(setFlagL !=25){
                z025.moveTo(610, 360);
            };
            if(setFlagL !=26){
                z026.moveTo(740, 360);
            };
        }        

        function funcUnVisible(){
            btnNext.visible = true;
            if(setFlagU != 11){
                z011.visible = false;
            };
            if(setFlagU != 12){
                z012.visible = false;
            };
            if(setFlagU != 13){
               z013.visible = false;
            };
            if(setFlagU != 14){
                z014.visible = false;
            };
            if(setFlagU != 15){
                z015.visible = false;
            };
            if(setFlagL != 21){
                z021.visible = false;
            };
            if(setFlagL != 22){
                z022.visible = false;
            };
            if(setFlagL != 23){
                z023.visible = false;
            };
            if(setFlagL != 24){
                z024.visible = false;
            };
            if(setFlagL != 25){
                z025.visible = false;
            };
            if(setFlagL != 26){
                z026.visible = false;
            };
            touchNumber =0;
            setFlagU =0;
            setFlagL =0;
            myFlag01 ="";
            myFlag02 ="";
        };

        function funcVisible(){
            z011.visible = true;
            z012.visible = true;
            z013.visible = true;
            z014.visible = true;
            z015.visible = true;
            z021.visible = true;
            z022.visible = true;
            z023.visible = true;
            z024.visible = true;
            z025.visible = true;
            z026.visible = true;
        };

        //もういちど　ボタン
        btnNext.ontouchstart = function(e){
            btnNext.visible = false;
            lblSetumei.text = "";
            funcVisible();
            funcReMoveU();
            funcReMoveL();
            game.rootScene.removeChild(spMaru);
        };

        //タッチされたら移動
        game.rootScene.ontouchmove = function(e){
            switch (touchNumber) {
                case 11:
                    z011.x= e.x - touchX;  
                    z011.y= e.y - touchY;
                    itiX =  e.x - touchX;
                    itiY =  e.y - touchY;
                    if (((baseEntity.x - gosaX) < itiX )&&
                        (itiX < (baseEntity.x + gosaX)) &&
                        ((baseEntity.y - gosaY) < itiY )&&
                        (itiY < (baseEntity.y + gosaY))){                    
                        z011.x = baseEntity.x;
                        z011.y = baseEntity.y;
                        setFlagU =11;
                        myFlag01 = "のぎへん";
                        funcReMoveU();
                    };
                    break;
                case 12:
                    z012.x= e.x - touchX;  
                    z012.y= e.y - touchY;
                    itiX =  e.x - touchX;
                    itiY =  e.y - touchY;
                    if (((baseEntity.x - gosaX) < itiX )&&
                        (itiX < (baseEntity.x + gosaX)) &&
                        ((baseEntity.y - gosaY) < itiY )&&
                        (itiY < (baseEntity.y + gosaY))){                    
                        z012.x = baseEntity.x;
                        z012.y = baseEntity.y;
                        setFlagU =12;
                        myFlag01 = "孝";
                        funcReMoveU();
                    };
                    break;
                case 13:
                    z013.x= e.x - touchX;  
                    z013.y= e.y - touchY;
                    itiX =  e.x - touchX;
                    itiY =  e.y - touchY;
                    if (((baseEntity.x - gosaX) < itiX )&&
                        (itiX < (baseEntity.x + gosaX)) &&
                        ((baseEntity.y - gosaY) < itiY )&&
                        (itiY < (baseEntity.y + gosaY))){                    
                        z013.x = baseEntity.x;
                        z013.y = baseEntity.y;
                        setFlagU =13;
                        myFlag01 = "ごんべん";
                        funcReMoveU();
                    };
                    break;
                case 14:
                    z014.x= e.x - touchX;  
                    z014.y= e.y - touchY;
                    itiX =  e.x - touchX;
                    itiY =  e.y - touchY;
                    if (((baseEntity.x - gosaX) < itiX )&&
                        (itiX < (baseEntity.x + gosaX)) &&
                        ((baseEntity.y - gosaY) < itiY )&&
                        (itiY < (baseEntity.y + gosaY))){                    
                        z014.x = baseEntity.x;
                        z014.y = baseEntity.y;
                        setFlagU =14;
                        myFlag01 = "日";
                        funcReMoveU();
                    };
                    break;
                case 15:
                    z015.x= e.x - touchX;  
                    z015.y= e.y - touchY;
                    itiX =  e.x - touchX;
                    itiY =  e.y - touchY;
                    if (((baseEntity.x - gosaX) < itiX )&&
                        (itiX < (baseEntity.x + gosaX)) &&
                        ((baseEntity.y - gosaY) < itiY )&&
                        (itiY < (baseEntity.y + gosaY))){                    
                        z015.x = baseEntity.x;
                        z015.y = baseEntity.y;
                        setFlagU =15;
                        myFlag01 = "さんずい";
                        funcReMoveU();
                    };
                    break;
                case 21:
                    itiX =  e.x - touchX;
                    itiY =  e.y - touchY;
                    z021.x= itiX;  
                    z021.y= itiY;
                    if (((baseEntity.x + 80 - gosaX) < itiX )&&
                        (itiX < (baseEntity.x + 80 + gosaX)) &&
                        ((baseEntity.y - gosaY) < itiY )&&
                        (itiY < (baseEntity.y + gosaY))){                    
                        z021.x = baseEntity.x + 80;
                        z021.y = baseEntity.y;
                        setFlagL =21;
                        myFlag02 = "斗";
                        funcReMoveL();
                    };
                    break;
                case 22:
                    itiX =  e.x - touchX;
                    itiY =  e.y - touchY;
                    z022.x= itiX;  
                    z022.y= itiY;
                    if (((baseEntity.x + 80 - gosaX) < itiX )&&
                        (itiX < (baseEntity.x + 80 + gosaX)) &&
                        ((baseEntity.y - gosaY) < itiY )&&
                        (itiY < (baseEntity.y + gosaY))){                    
                        z022.x = baseEntity.x + 80;
                        z022.y = baseEntity.y;
                        setFlagL =22;
                        myFlag02 = "枚";
                        funcReMoveL();
                    };
                    break;
                case 23:
                    itiX =  e.x - touchX;
                    itiY =  e.y - touchY;
                    z023.x= itiX;  
                    z023.y= itiY;
                    if (((baseEntity.x + 80 - gosaX) < itiX )&&
                        (itiX < (baseEntity.x + 80 + gosaX)) &&
                        ((baseEntity.y - gosaY) < itiY )&&
                        (itiY < (baseEntity.y + gosaY))){                    
                        z023.x = baseEntity.x + 80;
                        z023.y = baseEntity.y;
                        setFlagL =23;
                        myFlag02 = "吾";
                        funcReMoveL();
                    };
                    break;
                case 24:
                    itiX =  e.x - touchX;
                    itiY =  e.y - touchY;
                    z024.x= itiX;  
                    z024.y= itiY;
                    if (((baseEntity.x + 80 - gosaX) < itiX )&&
                        (itiX < (baseEntity.x + 80 + gosaX)) &&
                        ((baseEntity.y - gosaY) < itiY )&&
                        (itiY < (baseEntity.y + gosaY))){                    
                        z024.x = baseEntity.x + 80;
                        z024.y = baseEntity.y;
                        setFlagL =24;
                        myFlag02 = "青";
                        funcReMoveL();
                    };
                    break;
                case 25:
                    itiX =  e.x - touchX;
                    itiY =  e.y - touchY;
                    z025.x= itiX;  
                    z025.y= itiY;
                    if (((baseEntity.x + 80 - gosaX) < itiX )&&
                        (itiX < (baseEntity.x + 80 + gosaX)) &&
                        ((baseEntity.y - gosaY) < itiY )&&
                        (itiY < (baseEntity.y + gosaY))){                    
                        z025.x = baseEntity.x + 80;
                        z025.y = baseEntity.y;
                        setFlagL =25;
                        myFlag02 = "毎";
                        funcReMoveL();
                    };
                    break;
                case 26:
                    itiX =  e.x - touchX;
                    itiY =  e.y - touchY;
                    z026.x= itiX;  
                    z026.y= itiY;
                    if (((baseEntity.x + 80 - gosaX) < itiX )&&
                        (itiX < (baseEntity.x + 80 + gosaX)) &&
                        ((baseEntity.y - gosaY) < itiY )&&
                        (itiY < (baseEntity.y + gosaY))){                    
                        z026.x = baseEntity.x + 80;
                        z026.y = baseEntity.y;
                        setFlagL =26;
                        myFlag02 = "巻";
                        funcReMoveL();
                    };
                    break;
            }
            //判定
            if((myFlag01 !="")&&(myFlag02 !="")){
                if ((myFlag01 == "のぎへん") && (myFlag02 == "斗")){
                    lblText.text = lblText.text + "科";
                    lblSetumei.text = "カ";
                    spMaru.visible =true;
                    funcUnVisible();
                    game.rootScene.addChild(spMaru);
                }else if((myFlag01 == "孝") && (myFlag02 == "枚")){
                    lblText.text = lblText.text + "教";
                    lblSetumei.text = "キョウ<br>おし（える）<br>おそ（わる）";
                    spMaru.visible =true;
                    funcUnVisible();   
                    game.rootScene.addChild(spMaru);
                }else if((myFlag01 == "ごんべん") && (myFlag02 == "吾")){
                    lblText.text = lblText.text + "語";
                    lblSetumei.text = "ゴ<br>かた（る）<br>かた（らう）";
                    spMaru.visible =true;
                    funcUnVisible();    
                    game.rootScene.addChild(spMaru);
                }else if((myFlag01 == "日") && (myFlag02 == "青")){
                    lblText.text = lblText.text + "晴";
                    lblSetumei.text = "セイ<br>は（れる）<br>は（らす）";
                    spMaru.visible =true;
                    funcUnVisible();   
                    game.rootScene.addChild(spMaru);
                }else if((myFlag01 == "さんずい") && (myFlag02 == "毎")){
                    lblText.text = lblText.text + "海";
                    lblSetumei.text = "カイ<br>うみ";
                    spMaru.visible =true;
                    funcUnVisible();
                    game.rootScene.addChild(spMaru);
                }else if((myFlag01 == "さんずい") && (myFlag02 == "巻")){
                    lblText.text = lblText.text + "港";
                    lblSetumei.text = "コウ<br>みなと";
                    spMaru.visible =true;
                    funcUnVisible();   
                    game.rootScene.addChild(spMaru);
                }else if((myFlag01 == "さんずい") && (myFlag02 == "青")){
                    lblText.text = lblText.text + "清";
                    lblSetumei.text = "セイ、ショウ<br>きよ（い）";
                    spMaru.visible =true;
                    funcUnVisible();   
                    game.rootScene.addChild(spMaru);
                }else if((myFlag01 == "ごんべん") && (myFlag02 == "青")){
                    lblText.text = lblText.text + "請";
                    lblSetumei.text = "セイ、シン<br>ショウ<br>こ（う）";
                    spMaru.visible =true;
                    funcUnVisible();   
                    game.rootScene.addChild(spMaru);
                }else{
                    //組み合わせが違う場合
                    timeFlag = 1;
                    myTime = game.frame;
                    game.rootScene.addChild(coverEntity);
                }    

            }        
        }
        
        // 上下に動かす
        function funcFalse(i){
            if(setFlagU ==11){
                z011.x = baseEntity.x + i;
            }else if(setFlagU ==12){
                z012.x = baseEntity.x + i;
            }else if(setFlagU ==13){
                z013.x = baseEntity.x + i;
            }else if(setFlagU ==14){
                z014.x = baseEntity.x + i;
            }else if(setFlagU ==15){
                z015.x = baseEntity.x + i;
            };
            if(setFlagL ==21){
                z021.x = baseEntity.x + 80 - i;
            }else if(setFlagL ==22){
                z022.x = baseEntity.x + 80 - i;
            }else if(setFlagL ==23){
                z023.x = baseEntity.x + 80 - i;
            }else if(setFlagL ==24){
                z024.x = baseEntity.x + 80 - i;
            }else if(setFlagL ==25){
                z025.x = baseEntity.x + 80 - i;
            }else if(setFlagL ==26){
                z026.x = baseEntity.x + 80 - i;
            };
    
        };
                    
        //組み合わせが違う場合の処理
        game.rootScene.onenterframe = function(){
            if(timeFlag == 1){
                nowTime = Math.floor((game.frame -myTime) / game.fps*4);
                if(nowTime == 1){
                    funcFalse(-20);
                }else if(nowTime == 2){
                    funcFalse(0);                
                }else if(nowTime == 3){
                    funcFalse(-20);                
                }else if(nowTime == 4){
                    funcFalse(0);                
                }else if(nowTime == 5){
                    funcFalse(-20);                
                }else if(nowTime == 6){
                    funcFalse(0);                
                }else if(nowTime == 7){
                    funcFalse(-20);                
                }else if(nowTime == 8){
                    funcFalse(0);                
                }else if(nowTime == 9){
                    funcFalse(-20);                
                }else if(nowTime == 10){
                    timeFlag = 0;
                    funcFalse(0);                
                    game.rootScene.removeChild(coverEntity);
                    touchNumber =0;
                    setFlagU =0;
                    setFlagL =0;
                    myFlag01 ="";
                    myFlag02 ="";                
                    funcVisible();
                    funcReMoveU();
                    funcReMoveL();
                };

            };
        };            
    };
    game.start();
};

